require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__SPARC_MMU_CONTEXT_H)) {
    eval 'sub __SPARC_MMU_CONTEXT_H () {1;}' unless defined(&__SPARC_MMU_CONTEXT_H);
    require 'asm/btfixup.ph';
    unless(defined(&__ASSEMBLY__)) {
	eval 'sub init_new_context {
	    local($tsk, $mm) = @_;
    	    eval q(((($mm)-> &context =  &NO_CONTEXT), 0));
	}' unless defined(&init_new_context);
	eval 'sub destroy_context {
	    local($mm) = @_;
    	    eval q( &BTFIXUP_CALL($mm));
	}' unless defined(&destroy_context);
	eval 'sub switch_mm {
	    local($old_mm, $mm, $tsk, $cpu) = @_;
    	    eval q( &BTFIXUP_CALL($old_mm, $mm, $tsk, $cpu));
	}' unless defined(&switch_mm);
	eval 'sub activate_mm {
	    local($active_mm, $mm) = @_;
    	    eval q( &switch_mm(($active_mm), ($mm),  &NULL,  &smp_processor_id()));
	}' unless defined(&activate_mm);
    }
}
1;
