require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_SPARC64_ELF_H)) {
    eval 'sub __ASM_SPARC64_ELF_H () {1;}' unless defined(&__ASM_SPARC64_ELF_H);
    require 'asm/ptrace.ph';
    if(defined(&__KERNEL__)) {
	require 'asm/processor.ph';
    }
    unless(defined(&ELF_ARCH)) {
	eval 'sub ELF_ARCH () { &EM_SPARCV9;}' unless defined(&ELF_ARCH);
	eval 'sub ELF_CLASS () { &ELFCLASS64;}' unless defined(&ELF_CLASS);
	eval 'sub ELF_DATA () { &ELFDATA2MSB;}' unless defined(&ELF_DATA);
	eval 'sub ELF_NGREG () {36;}' unless defined(&ELF_NGREG);
	require 'asm/psrcompat.ph';
	eval 'sub ELF_CORE_COPY_REGS {
	    local($__elf_regs, $__pt_regs) = @_;
    	    eval q( &do { \'unsigned long\' * &dest = ($__elf_regs->[0]); \'struct pt_regs\' * &src = ; \'unsigned long\' * &sp; \'int\'  &i;  &for( &i = 0;  &i < 16;  &i++)  $dest[ &i] =  ($src->{u_regs[&i]});  &set_fs;  &sp = (( ($src->{u_regs[14]}) +  &STACK_BIAS) & 1.84467440737096e+19);  &for( &i = 0;  &i < 16;  &i++)  &__get_user( $dest[ &i+16],  $sp[ &i]);  &set_fs( &KERNEL_DS);  $dest[32] =  ($src->{tstate});  $dest[33] =  ($src->{tpc});  $dest[34] =  ($src->{tnpc});  $dest[35] =  ($src->{y}); }  &while (0););
	}' unless defined(&ELF_CORE_COPY_REGS);
    }
    unless(defined(&elf_check_arch)) {
	eval 'sub elf_check_arch {
	    local($x) = @_;
    	    eval q((($x)-> &e_machine ==  &ELF_ARCH));
	}' unless defined(&elf_check_arch);
    }
    eval 'sub USE_ELF_CORE_DUMP () {1;}' unless defined(&USE_ELF_CORE_DUMP);
    eval 'sub ELF_EXEC_PAGESIZE () { &PAGE_SIZE;}' unless defined(&ELF_EXEC_PAGESIZE);
    unless(defined(&ELF_ET_DYN_BASE)) {
	eval 'sub ELF_ET_DYN_BASE () {1099511627776;}' unless defined(&ELF_ET_DYN_BASE);
    }
    eval 'sub ELF_HWCAP () {(( &HWCAP_SPARC_FLUSH |  &HWCAP_SPARC_STBAR |  &HWCAP_SPARC_SWAP |  &HWCAP_SPARC_MULDIV |  &HWCAP_SPARC_V9) | (( &tlb_type ==  &cheetah ||  &tlb_type ==  &cheetah_plus) ?  &HWCAP_SPARC_ULTRA3 : 0));}' unless defined(&ELF_HWCAP);
    eval 'sub ELF_PLATFORM () {( &NULL);}' unless defined(&ELF_PLATFORM);
    if(defined(&__KERNEL__)) {
	eval 'sub SET_PERSONALITY {
	    local($ex, $ibcs2) = @_;
    	    eval q( &do { \'unsigned char flags\' =  ($current->{thread}->{flags});  &if (. $e_ident[ &EI_CLASS] ==  &ELFCLASS32)  &flags |=  &SPARC_FLAG_32BIT;  &else  &flags &= ~ &SPARC_FLAG_32BIT;  &if ( &flags !=  ($current->{thread}->{flags})) {  ($current->{thread}->{flags}) |=  &SPARC_FLAG_ABI_PENDING; }  &else {  ($current->{thread}->{flags}) &= ~ &SPARC_FLAG_ABI_PENDING; }  &if  &set_personality( &PER_SVR4);  &else  &if ( ($current->{personality}) !=  &PER_LINUX32)  &set_personality( &PER_LINUX); }  &while (0));
	}' unless defined(&SET_PERSONALITY);
    }
}
1;
