require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SPARC64_IDE_H)) {
    eval 'sub _SPARC64_IDE_H () {1;}' unless defined(&_SPARC64_IDE_H);
    if(defined(&__KERNEL__)) {
	require 'linux/config.ph';
	require 'asm/pgalloc.ph';
	require 'asm/io.ph';
	require 'asm/hdreg.ph';
	require 'asm/page.ph';
	require 'asm/spitfire.ph';
	unless(defined(&MAX_HWIFS)) {
	    if(defined(&CONFIG_BLK_DEV_IDEPCI)) {
		eval 'sub MAX_HWIFS () {10;}' unless defined(&MAX_HWIFS);
	    } else {
		eval 'sub MAX_HWIFS () {2;}' unless defined(&MAX_HWIFS);
	    }
	}
	unless(defined(&CONFIG_BLK_DEV_IDEPCI)) {
	}
	undef(&SUPPORT_SLOW_DATA_PORTS) if defined(&SUPPORT_SLOW_DATA_PORTS);
	eval 'sub SUPPORT_SLOW_DATA_PORTS () {0;}' unless defined(&SUPPORT_SLOW_DATA_PORTS);
	undef(&SUPPORT_VLB_SYNC) if defined(&SUPPORT_VLB_SYNC);
	eval 'sub SUPPORT_VLB_SYNC () {0;}' unless defined(&SUPPORT_VLB_SYNC);
	undef(&HD_DATA) if defined(&HD_DATA);
	eval 'sub HD_DATA () {(0);}' unless defined(&HD_DATA);
	eval 'sub __ide_insl {
	    local($data_reg, $buffer, $wcount) = @_;
    	    eval q( &__ide_insw($data_reg, $buffer, ($wcount)<<1));
	}' unless defined(&__ide_insl);
	eval 'sub __ide_outsl {
	    local($data_reg, $buffer, $wcount) = @_;
    	    eval q( &__ide_outsw($data_reg, $buffer, ($wcount)<<1));
	}' unless defined(&__ide_outsl);
	eval 'sub __ide_mm_insw () { &__ide_insw;}' unless defined(&__ide_mm_insw);
	eval 'sub __ide_mm_insl () { &__ide_insl;}' unless defined(&__ide_mm_insl);
	eval 'sub __ide_mm_outsw () { &__ide_outsw;}' unless defined(&__ide_mm_outsw);
	eval 'sub __ide_mm_outsl () { &__ide_outsl;}' unless defined(&__ide_mm_outsl);
	if(((defined(&L1DCACHE_SIZE) ? &L1DCACHE_SIZE : 0) > (defined(&PAGE_SIZE) ? &PAGE_SIZE : 0)) ) {
	}
	if(((defined(&L1DCACHE_SIZE) ? &L1DCACHE_SIZE : 0) > (defined(&PAGE_SIZE) ? &PAGE_SIZE : 0)) ) {
	}
	if(((defined(&L1DCACHE_SIZE) ? &L1DCACHE_SIZE : 0) > (defined(&PAGE_SIZE) ? &PAGE_SIZE : 0)) ) {
	}
	if(((defined(&L1DCACHE_SIZE) ? &L1DCACHE_SIZE : 0) > (defined(&PAGE_SIZE) ? &PAGE_SIZE : 0)) ) {
	}
    }
}
1;
