require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SPARC64_UPA_H)) {
    eval 'sub _SPARC64_UPA_H () {1;}' unless defined(&_SPARC64_UPA_H);
    require 'asm/asi.ph';
    eval 'sub UPA_CONFIG_RESV () {1.84467440726358e+19;}' unless defined(&UPA_CONFIG_RESV);
    eval 'sub UPA_CONFIG_PCON () {0x3fc00000;}' unless defined(&UPA_CONFIG_PCON);
    eval 'sub UPA_CONFIG_MID () {0x3e0000;}' unless defined(&UPA_CONFIG_MID);
    eval 'sub UPA_CONFIG_PCAP () {0x1ffff;}' unless defined(&UPA_CONFIG_PCAP);
    eval 'sub UPA_PORTID_FNP () {1.83746864796716e+19;}' unless defined(&UPA_PORTID_FNP);
    eval 'sub UPA_PORTID_RESV () {7.20575596781896e+16;}' unless defined(&UPA_PORTID_RESV);
    eval 'sub UPA_PORTID_ECCVALID () {17179869184;}' unless defined(&UPA_PORTID_ECCVALID);
    eval 'sub UPA_PORTID_ONEREAD () {8589934592;}' unless defined(&UPA_PORTID_ONEREAD);
    eval 'sub UPA_PORTID_PINTRDQ () {6442450944;}' unless defined(&UPA_PORTID_PINTRDQ);
    eval 'sub UPA_PORTID_PREQDQ () {0x7e000000;}' unless defined(&UPA_PORTID_PREQDQ);
    eval 'sub UPA_PORTID_PREQRD () {0x1e00000;}' unless defined(&UPA_PORTID_PREQRD);
    eval 'sub UPA_PORTID_UPACAP () {0x1f0000;}' unless defined(&UPA_PORTID_UPACAP);
    eval 'sub UPA_PORTID_ID () {0xffff;}' unless defined(&UPA_PORTID_ID);
    if(defined( &__KERNEL__)  && !defined( &__ASSEMBLY__)) {
	eval 'sub upa_readb {
	    local($__addr) = @_;
    	    eval q(( &_upa_readb(($__addr))));
	}' unless defined(&upa_readb);
	eval 'sub upa_readw {
	    local($__addr) = @_;
    	    eval q(( &_upa_readw(($__addr))));
	}' unless defined(&upa_readw);
	eval 'sub upa_readl {
	    local($__addr) = @_;
    	    eval q(( &_upa_readl(($__addr))));
	}' unless defined(&upa_readl);
	eval 'sub upa_readq {
	    local($__addr) = @_;
    	    eval q(( &_upa_readq(($__addr))));
	}' unless defined(&upa_readq);
	eval 'sub upa_writeb {
	    local($__b, $__addr) = @_;
    	    eval q(( &_upa_writeb(, ($__addr))));
	}' unless defined(&upa_writeb);
	eval 'sub upa_writew {
	    local($__w, $__addr) = @_;
    	    eval q(( &_upa_writew(, ($__addr))));
	}' unless defined(&upa_writew);
	eval 'sub upa_writel {
	    local($__l, $__addr) = @_;
    	    eval q(( &_upa_writel(, ($__addr))));
	}' unless defined(&upa_writel);
	eval 'sub upa_writeq {
	    local($__q, $__addr) = @_;
    	    eval q(( &_upa_writeq(, ($__addr))));
	}' unless defined(&upa_writeq);
    }
}
1;
