require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SPARC_IDE_H)) {
    eval 'sub _SPARC_IDE_H () {1;}' unless defined(&_SPARC_IDE_H);
    if(defined(&__KERNEL__)) {
	require 'linux/config.ph';
	require 'asm/pgtable.ph';
	require 'asm/io.ph';
	require 'asm/hdreg.ph';
	require 'asm/psr.ph';
	undef(&MAX_HWIFS) if defined(&MAX_HWIFS);
	eval 'sub MAX_HWIFS () {2;}' unless defined(&MAX_HWIFS);
	unless(defined(&CONFIG_BLK_DEV_IDEPCI)) {
	}
	undef(&SUPPORT_SLOW_DATA_PORTS) if defined(&SUPPORT_SLOW_DATA_PORTS);
	eval 'sub SUPPORT_SLOW_DATA_PORTS () {0;}' unless defined(&SUPPORT_SLOW_DATA_PORTS);
	undef(&SUPPORT_VLB_SYNC) if defined(&SUPPORT_VLB_SYNC);
	eval 'sub SUPPORT_VLB_SYNC () {0;}' unless defined(&SUPPORT_VLB_SYNC);
	undef(&HD_DATA) if defined(&HD_DATA);
	eval 'sub HD_DATA () {(0);}' unless defined(&HD_DATA);
	if(defined(&insl)) {
	    undef(&insl) if defined(&insl);
	}
	if(defined(&outsl)) {
	    undef(&outsl) if defined(&outsl);
	}
	if(defined(&insw)) {
	    undef(&insw) if defined(&insw);
	}
	if(defined(&outsw)) {
	    undef(&outsw) if defined(&outsw);
	}
	eval 'sub insl {
	    local($data_reg, $buffer, $wcount) = @_;
    	    eval q( &insw($data_reg, $buffer, ($wcount)<<1));
	}' unless defined(&insl);
	eval 'sub outsl {
	    local($data_reg, $buffer, $wcount) = @_;
    	    eval q( &outsw($data_reg, $buffer, ($wcount)<<1));
	}' unless defined(&outsl);
	eval 'sub insw {
	    local($port, $buf, $nr) = @_;
    	    eval q( &ide_insw(($port), ($buf), ($nr)));
	}' unless defined(&insw);
	eval 'sub outsw {
	    local($port, $buf, $nr) = @_;
    	    eval q( &ide_outsw(($port), ($buf), ($nr)));
	}' unless defined(&outsw);
    }
}
1;
