require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SPARC64_PGTABLE_H)) {
    eval 'sub _SPARC64_PGTABLE_H () {1;}' unless defined(&_SPARC64_PGTABLE_H);
    require 'asm/spitfire.ph';
    require 'asm/asi.ph';
    require 'asm/mmu_context.ph';
    require 'asm/system.ph';
    require 'asm/page.ph';
    require 'asm/processor.ph';
    eval 'sub TLBTEMP_BASE () {0x1000000;}' unless defined(&TLBTEMP_BASE);
    eval 'sub MODULES_VADDR () {0x2000000;}' unless defined(&MODULES_VADDR);
    eval 'sub MODULES_LEN () {0x7e000000;}' unless defined(&MODULES_LEN);
    eval 'sub MODULES_END () {0x80000000;}' unless defined(&MODULES_END);
    eval 'sub VMALLOC_START () {5368709120;}' unless defined(&VMALLOC_START);
    eval 'sub VMALLOC_VMADDR {
        local($x) = @_;
	    eval q((($x)));
    }' unless defined(&VMALLOC_VMADDR);
    eval 'sub VMALLOC_END () {8589934592;}' unless defined(&VMALLOC_END);
    eval 'sub LOW_OBP_ADDRESS () {0xf0000000;}' unless defined(&LOW_OBP_ADDRESS);
    eval 'sub HI_OBP_ADDRESS () {4294967296;}' unless defined(&HI_OBP_ADDRESS);
    eval 'sub PMD_SHIFT () {( &PAGE_SHIFT + ( &PAGE_SHIFT-3));}' unless defined(&PMD_SHIFT);
    eval 'sub PMD_SIZE () {(1 <<  &PMD_SHIFT);}' unless defined(&PMD_SIZE);
    eval 'sub PMD_MASK () {(~( &PMD_SIZE-1));}' unless defined(&PMD_MASK);
    eval 'sub PMD_BITS () {11;}' unless defined(&PMD_BITS);
    eval 'sub PGDIR_SHIFT () {( &PAGE_SHIFT + ( &PAGE_SHIFT-3) +  &PMD_BITS);}' unless defined(&PGDIR_SHIFT);
    eval 'sub PGDIR_SIZE () {(1 <<  &PGDIR_SHIFT);}' unless defined(&PGDIR_SIZE);
    eval 'sub PGDIR_MASK () {(~( &PGDIR_SIZE-1));}' unless defined(&PGDIR_MASK);
    unless(defined(&__ASSEMBLY__)) {
	eval 'sub set_pte {
	    local($pteptr, $pteval) = @_;
    	    eval q(((*($pteptr)) = ($pteval)));
	}' unless defined(&set_pte);
	eval 'sub PTRS_PER_PTE () {(1 << ( &PAGE_SHIFT-3));}' unless defined(&PTRS_PER_PTE);
	eval 'sub REAL_PTRS_PER_PMD () {(1 <<  &PMD_BITS);}' unless defined(&REAL_PTRS_PER_PMD);
	eval 'sub PTRS_PER_PMD () {((( ($current->{thread}->{flags}) &  &SPARC_FLAG_32BIT) ? (1 << (32- ( &PAGE_SHIFT-3) -  &PAGE_SHIFT)) : ( &REAL_PTRS_PER_PMD)));}' unless defined(&PTRS_PER_PMD);
	eval 'sub PTRS_PER_PGD () {(((1 <<  &VA_BITS) -  &VPTE_SIZE + (1 << ( &PAGE_SHIFT + ( &PAGE_SHIFT-3) +  &PMD_BITS)) - 1) / (1 << ( &PAGE_SHIFT + ( &PAGE_SHIFT-3) +  &PMD_BITS)));}' unless defined(&PTRS_PER_PGD);
	eval 'sub USER_PTRS_PER_PGD () {((( ($current->{thread}->{flags}) &  &SPARC_FLAG_32BIT) ? (1) : ( &PTRS_PER_PGD)));}' unless defined(&USER_PTRS_PER_PGD);
	eval 'sub FIRST_USER_PGD_NR () {0;}' unless defined(&FIRST_USER_PGD_NR);
	eval 'sub pte_ERROR {
	    local($e) = @_;
    	    eval q( &__builtin_trap());
	}' unless defined(&pte_ERROR);
	eval 'sub pmd_ERROR {
	    local($e) = @_;
    	    eval q( &__builtin_trap());
	}' unless defined(&pmd_ERROR);
	eval 'sub pgd_ERROR {
	    local($e) = @_;
    	    eval q( &__builtin_trap());
	}' unless defined(&pgd_ERROR);
    }
    eval 'sub _PAGE_VALID () {9.22337203685478e+18;}' unless defined(&_PAGE_VALID);
    eval 'sub _PAGE_R () {9.22337203685478e+18;}' unless defined(&_PAGE_R);
    eval 'sub _PAGE_SZ4MB () {6.91752902764108e+18;}' unless defined(&_PAGE_SZ4MB);
    eval 'sub _PAGE_SZ512K () {4.61168601842739e+18;}' unless defined(&_PAGE_SZ512K);
    eval 'sub _PAGE_SZ64K () {2.30584300921369e+18;}' unless defined(&_PAGE_SZ64K);
    eval 'sub _PAGE_SZ8K () {0x;}' unless defined(&_PAGE_SZ8K);
    eval 'sub _PAGE_NFO () {1.15292150460685e+18;}' unless defined(&_PAGE_NFO);
    eval 'sub _PAGE_IE () {5.76460752303423e+17;}' unless defined(&_PAGE_IE);
    eval 'sub _PAGE_SN () {140737488355328;}' unless defined(&_PAGE_SN);
    eval 'sub _PAGE_PADDR_SF () {2199023247360;}' unless defined(&_PAGE_PADDR_SF);
    eval 'sub _PAGE_PADDR () {8796093014016;}' unless defined(&_PAGE_PADDR);
    eval 'sub _PAGE_SOFT () {0x1f80;}' unless defined(&_PAGE_SOFT);
    eval 'sub _PAGE_L () {0x40;}' unless defined(&_PAGE_L);
    eval 'sub _PAGE_CP () {0x20;}' unless defined(&_PAGE_CP);
    eval 'sub _PAGE_CV () {0x10;}' unless defined(&_PAGE_CV);
    eval 'sub _PAGE_E () {0x8;}' unless defined(&_PAGE_E);
    eval 'sub _PAGE_P () {0x4;}' unless defined(&_PAGE_P);
    eval 'sub _PAGE_W () {0x2;}' unless defined(&_PAGE_W);
    eval 'sub _PAGE_G () {0x1;}' unless defined(&_PAGE_G);
    eval 'sub _PAGE_MODIFIED () {0x800;}' unless defined(&_PAGE_MODIFIED);
    eval 'sub _PAGE_ACCESSED () {0x400;}' unless defined(&_PAGE_ACCESSED);
    eval 'sub _PAGE_READ () {0x200;}' unless defined(&_PAGE_READ);
    eval 'sub _PAGE_WRITE () {0x100;}' unless defined(&_PAGE_WRITE);
    eval 'sub _PAGE_PRESENT () {0x80;}' unless defined(&_PAGE_PRESENT);
    if((defined(&PAGE_SHIFT) ? &PAGE_SHIFT : 0) == 13) {
	eval 'sub _PAGE_SZBITS () { &_PAGE_SZ8K;}' unless defined(&_PAGE_SZBITS);
    }
 elsif((defined(&PAGE_SHIFT) ? &PAGE_SHIFT : 0) == 16) {
	eval 'sub _PAGE_SZBITS () { &_PAGE_SZ64K;}' unless defined(&_PAGE_SZBITS);
    }
 elsif((defined(&PAGE_SHIFT) ? &PAGE_SHIFT : 0) == 19) {
	eval 'sub _PAGE_SZBITS () { &_PAGE_SZ512K;}' unless defined(&_PAGE_SZBITS);
    }
 elsif((defined(&PAGE_SHIFT) ? &PAGE_SHIFT : 0) == 22) {
	eval 'sub _PAGE_SZBITS () { &_PAGE_SZ4M;}' unless defined(&_PAGE_SZBITS);
    } else {
	die("Wrong\ PAGE_SHIFT\ specified");
    }
    eval 'sub _PAGE_CACHE () {( &_PAGE_CP |  &_PAGE_CV);}' unless defined(&_PAGE_CACHE);
    eval 'sub __DIRTY_BITS () {( &_PAGE_MODIFIED |  &_PAGE_WRITE |  &_PAGE_W);}' unless defined(&__DIRTY_BITS);
    eval 'sub __ACCESS_BITS () {( &_PAGE_ACCESSED |  &_PAGE_READ |  &_PAGE_R);}' unless defined(&__ACCESS_BITS);
    eval 'sub __PRIV_BITS () { &_PAGE_P;}' unless defined(&__PRIV_BITS);
    eval 'sub PAGE_NONE () { &__pgprot ( &_PAGE_PRESENT |  &_PAGE_ACCESSED);}' unless defined(&PAGE_NONE);
    eval 'sub PAGE_SHARED () { &__pgprot ( &_PAGE_PRESENT |  &_PAGE_VALID |  &_PAGE_CACHE |  &__ACCESS_BITS |  &_PAGE_WRITE);}' unless defined(&PAGE_SHARED);
    eval 'sub PAGE_COPY () { &__pgprot ( &_PAGE_PRESENT |  &_PAGE_VALID |  &_PAGE_CACHE |  &__ACCESS_BITS);}' unless defined(&PAGE_COPY);
    eval 'sub PAGE_READONLY () { &__pgprot ( &_PAGE_PRESENT |  &_PAGE_VALID |  &_PAGE_CACHE |  &__ACCESS_BITS);}' unless defined(&PAGE_READONLY);
    eval 'sub PAGE_KERNEL () { &__pgprot ( &_PAGE_PRESENT |  &_PAGE_VALID |  &_PAGE_CACHE |  &__PRIV_BITS |  &__ACCESS_BITS |  &__DIRTY_BITS);}' unless defined(&PAGE_KERNEL);
    eval 'sub PAGE_INVALID () { &__pgprot (0);}' unless defined(&PAGE_INVALID);
    eval 'sub _PFN_MASK () { &_PAGE_PADDR;}' unless defined(&_PFN_MASK);
    eval 'sub _PAGE_CHG_MASK () {( &_PFN_MASK |  &_PAGE_MODIFIED |  &_PAGE_ACCESSED |  &_PAGE_PRESENT |  &_PAGE_SZBITS);}' unless defined(&_PAGE_CHG_MASK);
    eval 'sub pg_iobits () {( &_PAGE_VALID |  &_PAGE_PRESENT |  &__DIRTY_BITS |  &__ACCESS_BITS |  &_PAGE_E);}' unless defined(&pg_iobits);
    eval 'sub __P000 () { &PAGE_NONE;}' unless defined(&__P000);
    eval 'sub __P001 () { &PAGE_READONLY;}' unless defined(&__P001);
    eval 'sub __P010 () { &PAGE_COPY;}' unless defined(&__P010);
    eval 'sub __P011 () { &PAGE_COPY;}' unless defined(&__P011);
    eval 'sub __P100 () { &PAGE_READONLY;}' unless defined(&__P100);
    eval 'sub __P101 () { &PAGE_READONLY;}' unless defined(&__P101);
    eval 'sub __P110 () { &PAGE_COPY;}' unless defined(&__P110);
    eval 'sub __P111 () { &PAGE_COPY;}' unless defined(&__P111);
    eval 'sub __S000 () { &PAGE_NONE;}' unless defined(&__S000);
    eval 'sub __S001 () { &PAGE_READONLY;}' unless defined(&__S001);
    eval 'sub __S010 () { &PAGE_SHARED;}' unless defined(&__S010);
    eval 'sub __S011 () { &PAGE_SHARED;}' unless defined(&__S011);
    eval 'sub __S100 () { &PAGE_READONLY;}' unless defined(&__S100);
    eval 'sub __S101 () { &PAGE_READONLY;}' unless defined(&__S101);
    eval 'sub __S110 () { &PAGE_SHARED;}' unless defined(&__S110);
    eval 'sub __S111 () { &PAGE_SHARED;}' unless defined(&__S111);
    unless(defined(&__ASSEMBLY__)) {
	eval 'sub ZERO_PAGE {
	    local($vaddr) = @_;
    	    eval q(( &mem_map_zero));
	}' unless defined(&ZERO_PAGE);
	eval 'sub mk_pte {
	    local($page, $pgprot) = @_;
    	    eval q( &__pte(((($page -  &mem_map) <<  &PAGE_SHIFT)+ &phys_base) |  &pgprot_val($pgprot) |  &_PAGE_SZBITS));
	}' unless defined(&mk_pte);
	eval 'sub page_pte_prot {
	    local($page, $prot) = @_;
    	    eval q( &mk_pte($page, $prot));
	}' unless defined(&page_pte_prot);
	eval 'sub page_pte {
	    local($page) = @_;
    	    eval q( &page_pte_prot($page,  &__pgprot(0)));
	}' unless defined(&page_pte);
	eval 'sub mk_pte_phys {
	    local($physpage, $pgprot) = @_;
    	    eval q(( &__pte(($physpage) |  &pgprot_val($pgprot) |  &_PAGE_SZBITS)));
	}' unless defined(&mk_pte_phys);
	eval 'sub pmd_set {
	    local($pmdp, $ptep) = @_;
    	    eval q(( &pmd_val(*) = ( &__pa( ($ptep)) >> 11)));
	}' unless defined(&pmd_set);
	eval 'sub pgd_set {
	    local($pgdp, $pmdp) = @_;
    	    eval q(( &pgd_val(*) = ( &__pa( ($pmdp)) >> 11)));
	}' unless defined(&pgd_set);
	eval 'sub pmd_page {
	    local($pmd) = @_;
    	    eval q((  &__va(( &pmd_val($pmd)<<11))));
	}' unless defined(&pmd_page);
	eval 'sub pgd_page {
	    local($pgd) = @_;
    	    eval q((  &__va(( &pgd_val($pgd)<<11))));
	}' unless defined(&pgd_page);
	eval 'sub pte_none {
	    local($pte) = @_;
    	    eval q((! &pte_val($pte)));
	}' unless defined(&pte_none);
	eval 'sub pte_present {
	    local($pte) = @_;
    	    eval q(( &pte_val($pte) &  &_PAGE_PRESENT));
	}' unless defined(&pte_present);
	eval 'sub pte_clear {
	    local($pte) = @_;
    	    eval q(( &pte_val(*($pte)) = 0));
	}' unless defined(&pte_clear);
	eval 'sub pmd_none {
	    local($pmd) = @_;
    	    eval q((! &pmd_val($pmd)));
	}' unless defined(&pmd_none);
	eval 'sub pmd_bad {
	    local($pmd) = @_;
    	    eval q((0));
	}' unless defined(&pmd_bad);
	eval 'sub pmd_present {
	    local($pmd) = @_;
    	    eval q(( &pmd_val($pmd) != 0));
	}' unless defined(&pmd_present);
	eval 'sub pmd_clear {
	    local($pmdp) = @_;
    	    eval q(( &pmd_val(*($pmdp)) = 0));
	}' unless defined(&pmd_clear);
	eval 'sub pgd_none {
	    local($pgd) = @_;
    	    eval q((! &pgd_val($pgd)));
	}' unless defined(&pgd_none);
	eval 'sub pgd_bad {
	    local($pgd) = @_;
    	    eval q((0));
	}' unless defined(&pgd_bad);
	eval 'sub pgd_present {
	    local($pgd) = @_;
    	    eval q(( &pgd_val($pgd) != 0));
	}' unless defined(&pgd_present);
	eval 'sub pgd_clear {
	    local($pgdp) = @_;
    	    eval q(( &pgd_val(*($pgdp)) = 0));
	}' unless defined(&pgd_clear);
	eval 'sub pte_read {
	    local($pte) = @_;
    	    eval q(( &pte_val($pte) &  &_PAGE_READ));
	}' unless defined(&pte_read);
	eval 'sub pte_exec {
	    local($pte) = @_;
    	    eval q( &pte_read($pte));
	}' unless defined(&pte_exec);
	eval 'sub pte_write {
	    local($pte) = @_;
    	    eval q(( &pte_val($pte) &  &_PAGE_WRITE));
	}' unless defined(&pte_write);
	eval 'sub pte_dirty {
	    local($pte) = @_;
    	    eval q(( &pte_val($pte) &  &_PAGE_MODIFIED));
	}' unless defined(&pte_dirty);
	eval 'sub pte_young {
	    local($pte) = @_;
    	    eval q(( &pte_val($pte) &  &_PAGE_ACCESSED));
	}' unless defined(&pte_young);
	eval 'sub pte_wrprotect {
	    local($pte) = @_;
    	    eval q(( &__pte( &pte_val($pte) & ~( &_PAGE_WRITE| &_PAGE_W))));
	}' unless defined(&pte_wrprotect);
	eval 'sub pte_rdprotect {
	    local($pte) = @_;
    	    eval q(( &__pte((( &pte_val($pte)<<1)>>1) & ~ &_PAGE_READ)));
	}' unless defined(&pte_rdprotect);
	eval 'sub pte_mkclean {
	    local($pte) = @_;
    	    eval q(( &__pte( &pte_val($pte) & ~( &_PAGE_MODIFIED| &_PAGE_W))));
	}' unless defined(&pte_mkclean);
	eval 'sub pte_mkold {
	    local($pte) = @_;
    	    eval q(( &__pte((( &pte_val($pte)<<1)>>1) & ~ &_PAGE_ACCESSED)));
	}' unless defined(&pte_mkold);
	eval 'sub __page_address {
	    local($page) = @_;
    	    eval q( &page_address($page));
	}' unless defined(&__page_address);
	eval 'sub pte_page {
	    local($x) = @_;
    	    eval q(( &mem_map+((( &pte_val($x)& &_PAGE_PADDR)- &phys_base)>> &PAGE_SHIFT)));
	}' unless defined(&pte_page);
	eval 'sub pte_mkyoung {
	    local($pte) = @_;
    	    eval q(( &__pte( &pte_val($pte) |  &_PAGE_ACCESSED |  &_PAGE_R)));
	}' unless defined(&pte_mkyoung);
	eval 'sub pte_mkwrite {
	    local($pte) = @_;
    	    eval q(( &__pte( &pte_val($pte) |  &_PAGE_WRITE)));
	}' unless defined(&pte_mkwrite);
	eval 'sub pte_mkdirty {
	    local($pte) = @_;
    	    eval q(( &__pte( &pte_val($pte) |  &_PAGE_MODIFIED |  &_PAGE_W)));
	}' unless defined(&pte_mkdirty);
	eval 'sub pgd_index {
	    local($address) = @_;
    	    eval q(((($address) >>  &PGDIR_SHIFT) & ( &PTRS_PER_PGD)));
	}' unless defined(&pgd_index);
	eval 'sub pgd_offset {
	    local($mm, $address) = @_;
    	    eval q((($mm)-> &pgd +  &pgd_index($address)));
	}' unless defined(&pgd_offset);
	eval 'sub pgd_offset_k {
	    local($address) = @_;
    	    eval q( &pgd_offset( &init_mm, $address));
	}' unless defined(&pgd_offset_k);
	eval 'sub pmd_offset {
	    local($dir, $address) = @_;
    	    eval q((  &pgd_page(*($dir)) + (($address >>  &PMD_SHIFT) & ( &REAL_PTRS_PER_PMD-1))));
	}' unless defined(&pmd_offset);
	eval 'sub pte_offset {
	    local($dir, $address) = @_;
    	    eval q((  &pmd_page(*($dir)) + (($address >>  &PAGE_SHIFT) & ( &PTRS_PER_PTE - 1))));
	}' unless defined(&pte_offset);
	eval 'sub mmu_lockarea {
	    local($vaddr, $len) = @_;
    	    eval q(($vaddr));
	}' unless defined(&mmu_lockarea);
	eval 'sub mmu_unlockarea {
	    local($vaddr, $len) = @_;
    	    eval q( &do { }  &while(0));
	}' unless defined(&mmu_unlockarea);
	eval 'sub flush_icache_page {
	    local($vma, $pg) = @_;
    	    eval q( &do { }  &while(0));
	}' unless defined(&flush_icache_page);
	eval 'sub flush_icache_user_range {
	    local($vma,$pg,$adr,$len) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&flush_icache_user_range);
	eval 'sub SWP_TYPE {
	    local($entry) = @_;
    	    eval q(((($entry). &val >>  &PAGE_SHIFT) & 0xff));
	}' unless defined(&SWP_TYPE);
	eval 'sub SWP_OFFSET {
	    local($entry) = @_;
    	    eval q((($entry). &val >> ( &PAGE_SHIFT + 8)));
	}' unless defined(&SWP_OFFSET);
	eval 'sub SWP_ENTRY {
	    local($type, $offset) = @_;
    	    eval q(( { (( <<  &PAGE_SHIFT) | (($offset) << ( &PAGE_SHIFT + 8))) } ));
	}' unless defined(&SWP_ENTRY);
	eval 'sub pte_to_swp_entry {
	    local($pte) = @_;
    	    eval q((( &swp_entry_t) {  &pte_val($pte) }));
	}' unless defined(&pte_to_swp_entry);
	eval 'sub swp_entry_to_pte {
	    local($x) = @_;
    	    eval q((( &pte_t) { ($x). &val }));
	}' unless defined(&swp_entry_to_pte);
	eval 'sub kern_addr_valid {
	    local($addr) = @_;
    	    eval q(( &test_bit( &__pa(($addr))>>22,  &sparc64_valid_addr_bitmap)));
	}' unless defined(&kern_addr_valid);
	require 'asm-generic/pgtable.ph';
	eval 'sub HAVE_ARCH_UNMAPPED_AREA () {1;}' unless defined(&HAVE_ARCH_UNMAPPED_AREA);
	eval 'sub HAVE_ARCH_FB_UNMAPPED_AREA () {1;}' unless defined(&HAVE_ARCH_FB_UNMAPPED_AREA);
    }
    eval 'sub pgtable_cache_init () {
        eval q( &do { }  &while (0));
    }' unless defined(&pgtable_cache_init);
}
1;
